//+------------------------------------------------------------------+
//|                                                     ColorCCI.mq5 |
//|                                         Copyright  2013, ArtONE | 
//|                                                     artone@bk.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, ArtONE"
#property link "artone@bk.ru"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----    2
#property indicator_buffers 2 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----      
#property indicator_type1 DRAW_COLOR_LINE
//----      
#property indicator_color1 clrRed,clrGold,clrLime
//----   - 
#property indicator_style1 STYLE_SOLID
//----     2
#property indicator_width1 2
//----    
#property indicator_label1  "ColorCCI"
#property indicator_type2   DRAW_LINE
//+-----------------------------------+
//|                 |
//+-----------------------------------+
#define RESET  0 //        
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum WIDTH // 
  {
   W1 = 1,     //1
   W2,         //2
   W3,         //3
   W4,         //4
   W5          //5
  };
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum STYLE // 
  {
   SOLID = 0,     // 
   DASH,          // 
   DOT,           //
   DASHDOT,       //-
   DASHDOTDOT     //- 
  };
//+-----------------------------------+
//|         |
//+-----------------------------------+
input int iCCIPeriod=14;                              //  CCI
input ENUM_APPLIED_PRICE   iCCIPrice=PRICE_TYPICAL;   //   
input int iHighLevel=100;                             //  
input int iMiddleLevel=0;                             //  
input int iLowLevel=-100;                             //  
input color iColor=clrDarkGray;                       //  
input STYLE iStyle=STYLE_DOT;                         //   
input WIDTH iWidth=W1;                                //  

//----   ,   
//----      
double ColorBuffer[],ExtLineBuffer[];
//----      
int min_rates_total;
//----      
int CCI_Handle;
//----      
int HighLevel,MiddleLevel,LowLevel;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   min_rates_total=iCCIPeriod;
//----   
   HighLevel=MathMin(100,MathMax(0,iHighLevel));
   MiddleLevel=MathMin(100,MathMax(0,iMiddleLevel));
   LowLevel=MathMin(-100,MathMax(0,iLowLevel));

//----    iCCI
   CCI_Handle=iCCI(NULL,0,iCCIPeriod,iCCIPrice);
   if(CCI_Handle==INVALID_HANDLE) Print("      iCCI");

//----    ExtLineBuffer   
   SetIndexBuffer(0,ExtLineBuffer,INDICATOR_DATA);
//----      
   string shortname;
   StringConcatenate(shortname,"ColorCCI(",iCCIPeriod,")");
//----       
   PlotIndexSetString(0,PLOT_LABEL,shortname);
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//----     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//----      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----     ,     
   SetIndexBuffer(1,ColorBuffer,INDICATOR_COLOR_INDEX);

//----       
   ArraySetAsSeries(ExtLineBuffer,true);
   ArraySetAsSeries(ColorBuffer,true);

//----      3   
   IndicatorSetInteger(INDICATOR_LEVELS,3);
//----       
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,HighLevel);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,MiddleLevel);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,2,LowLevel);
//----             
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,0,iColor);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,1,clrGray);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,2,iColor);
//----       -  
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,0,iStyle);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,1,iStyle);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,2,iStyle);
//----   
   IndicatorSetInteger(INDICATOR_LEVELWIDTH,0,int(iWidth));
   IndicatorSetInteger(INDICATOR_LEVELWIDTH,1,int(iWidth));
   IndicatorSetInteger(INDICATOR_LEVELWIDTH,2,int(iWidth));
//----
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(BarsCalculated(CCI_Handle)<rates_total || rates_total<min_rates_total) return(RESET);

//----    
   int to_copy,limit,bar,clr;

//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=rates_total-1-min_rates_total; //      
     }
   else
     {
      limit=rates_total-prev_calculated; //      
     }

//----     
   to_copy=limit+1;

//----      
   if(CopyBuffer(CCI_Handle,0,0,to_copy,ExtLineBuffer)<=0) return(RESET);

//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      clr=1;
      double res=ExtLineBuffer[bar];

      if(res>HighLevel) clr=2;
      else if(res<LowLevel) clr=0;

      ColorBuffer[bar]=clr;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
